package pl.webnet.JaTrac;

class Intersection implements Comparable
{
	static final boolean ENTERING = true;
	static final boolean EXITING = false;
	
	double t;
	Primitive primitive;
	Surface surface;
	boolean entering;
	Ray shadowRays[];
	Ray specularRays[];
	Ray transmissionRays[];

	
	public Intersection(double t, Primitive prim, boolean entering, Surface surface)
	{
		this.t = t;
		primitive = prim;
		this.entering = entering;
		this.surface = surface;
	}

	public int compareTo(Object o)
	{
		if(t < ((Intersection)o).t)
			return -1;

		if(t > ((Intersection)o).t)
			return 1;

		return 0;
	}

}
