package pl.webnet.JaTrac;

import java.awt.*;
import java.util.*;

abstract class Light
{
	Point origin;
	Spectrum spectrum;
	double intensity;

	public Point getOrigin() { return origin; }
	public Spectrum getSpectrum() { return spectrum; }
	public double getIntensity() { return intensity; }
	public abstract Double shadow(RayTree rt, Point hitPoint, Vec lightVec, double len);

	public void setSpectrum(String sp)
	{
		spectrum = (Spectrum)ObjectIndex.find(sp, Spectrum.index);
	}
}

