package pl.webnet.JaTrac;

import java.lang.reflect.*;

class ParamHelper
{
	static public double[] extract3Doubles(String value)
	{
		double ret[] = new double[3];
		int idx;

		ret[0] = Double.valueOf(value.substring(0, idx = value.indexOf(" "))).doubleValue();
		ret[1] = Double.valueOf(value.substring(idx, idx = value.indexOf(" ", idx + 1))).doubleValue();
		ret[2] = Double.valueOf(value.substring(idx)).doubleValue();

		return ret;
	}

	static public double extractDouble(String value)
	{
		return Double.valueOf(value).doubleValue();
	}

	static public int extractInteger(String value)
	{
		return Integer.valueOf(value).intValue();
	}

	static public void addObject(Object caller, String[] params, Object o)
	{
		Method method;
		Class cl = o.getClass();

		do
		{
			System.out.println("looking for: " + cl.getName());

			try {
				for(int i = 0; i < params.length / 2; i++)
				{
					if(cl.getName().endsWith(params[i * 2]))
					{
						if(!params[i * 2 + 1].equals(""))
						{
							Class[] pTypes = new Class[] { cl };

						System.out.println("trying: " + caller + " " +params[i * 2 +1]+" "+cl);

							method = caller.getClass().getDeclaredMethod(params[i * 2 + 1], pTypes);

							System.out.println("invoking: " + method);
							method.invoke(caller, new Object[] {o});

							return;
						}
					}
				}

				System.out.println("Class " + cl + " not found");

			} catch (Exception e) { e.printStackTrace(); return;}

			cl = cl.getSuperclass();
		} while(!cl.getName().equals("pl.webnet.JaTrac") && !cl.getName().equals("java.lang.Object"));
	}

	static public void set(Object caller, String[] params, String param, String value)
	{
		Field field;
		Method method;
		Class cl = caller.getClass();


			for(int i = 0; i < params.length / 3; i++)
			{
				if(params[i * 3].equals(param))
				{
					// check if there is field to set
					if(!params[i * 3 + 1].equals(""))
					{
						Object o = null;

						do
						{
							try
							{
								field = cl.getDeclaredField(params[i * 3 + 1]);
								String name = field.getType().getName();

								if(name.endsWith(".Point"))
									o = new Point(ParamHelper.extract3Doubles(value));

								if(name.endsWith(".Vec"))
									o = new Vec(ParamHelper.extract3Doubles(value));

								if(name.equals("double"))
									o = new Double(ParamHelper.extractDouble(value));

								if(name.equals("int"))
									o = new Integer(ParamHelper.extractInteger(value));

								if(name.endsWith("String"))
									o = new String(value);

								field.set(caller, o);

								return;
							} catch (NoSuchFieldException e)
								{ cl = cl.getSuperclass(); }
								catch (Exception e)
								{ e.printStackTrace(); return; }

						} while(!cl.getName().equals("pl.webnet.JaTrac") && !cl.getName().equals("java.lang.Object"));
					}
					else
					{
						Class[] pTypes = new Class[] {String.class};

						do
						{
							try
							{
								method = cl.getDeclaredMethod(params[i * 3 + 2], pTypes);

								System.out.println("invoking: " + method);
								method.invoke(caller, new Object[] {value});

								return;
							} catch (NoSuchMethodException e)
								{ cl = cl.getSuperclass(); }
								catch (Exception e)
								{ e.printStackTrace(); return; }
						} while(!cl.getName().equals("pl.webnet.JaTrac") && !cl.getName().equals("java.lang.Object"));
					}
				}
			}
		}

}
